disasm:
include		"distable.inc"

.disasm_bss:
.disasmstart:	dq			0
.inst:		db			0
.rex:		db			0
.size:		db			0
.saddr:		db			0
.seg:		db			0
.segog:		db			0
.ip:		dq			0
.i_name:	dq			0
.i_size:	dd			0
.i_mode:	dd			0
.addr_reg:	db			0
.addr_ss:	db			0
.addr_disp:	dq			0
.addr_base:	dq			0
.addr_idx:	dq			0
.origout:       dq                      0

		;function to disasm x86_64 code
		;in: r8 location of current instruction, r9 output buffer
		;out: r8 location of next instruction, r9 buffer end
		;should preserve r12, r13, r14, r15, rbp

.decode:	mov			rdi, .disasm_bss
		xor			rax, rax
		mov			rcx, .decode-.disasm_bss
		repnz			stosb
		mov			rdi, r9
		mov			r12, r9
		mov			qword [.disasmstart], r8
		mov			qword [.origout], r9
		mov			rax, '        '
		stosq
		stosq
		xor			rax, rax
		stosb
		mov			rdi, r9
		mov			byte [.size], DA_LONG
		;prefix
.getbyte:	mov			rsi, r8
		clc
		cmp			rsi, sys.arch.apic
		jb			@f
		cmp			rsi, sys.arch.cpucb
		jb			.notmapped
@@:		lodsb
		jc			.notmapped
		inc			r8
        	cmp			al, 26h
		je			.segov
		cmp			al, 36h
		je			.segov
		cmp			al, 2eh
		je			.segov
		cmp			al, 3eh
		jne			@f
.segov:		jmp			.getbyte
@@:		cmp			al, 64h
		jne			@f
		mov			byte [.seg], 'f'
		jmp			.getbyte
@@:		cmp			al, 65h
		jne			@f
		mov			byte [.seg], 'g'
		jmp			.getbyte
@@:		cmp			al, 66h
		jne			@f
		mov			byte [.size], DA_WORD
		jmp			.getbyte
@@:		cmp			al, 67h
		jne			@f
		inc			byte [.saddr]
		jmp			.getbyte
@@:		cmp			al, 0f0h
		jne			@f
		mov			rsi, .lockstr
		call			.prtstr
		jmp			.getbyte
@@:		cmp			al, 0f2h
		jne			@f
		mov			rsi, .repnzstr
		call			.prtstr
		jmp			.getbyte
@@:		cmp			al, 0f3h
		jne			@f
		mov			rsi, .repestr
		call			.prtstr
		jmp			.getbyte
@@:		cmp			word [rsi-1], 050Fh
		je			.issyscall
		cmp			word [rsi-1], 01FCDh
		jne			@f
.issyscall:	inc			r8
		cmp			byte [rsi-6], 0B8h
		jne			.unksyscall
		mov			eax, dword [rsi-5]
		mov			rsi, .syscallstr
		cmp			eax, 'send'
		je			.syscallok
		cmp			eax, 'sgnl'
		je			.syscallok
		cmp			eax, 'recv'
		je			.syscallok
		cmp			eax, 'call'
		je			.syscallok
		cmp			eax, 'disp'
		je			.syscallok
.unksyscall:	mov			eax, '????'
.syscallok:	mov			dword [rsi+8],eax
		call			.prtstr
		jmp			.end

		;opcode
.getopcode:	xor			rax, rax
		mov			rsi, r8
		clc
		lodsb
		jc			.notmapped
		inc			r8
@@:		;nop
		cmp			al, 90h
		jne			@f
		mov			byte [rdi], 4
		inc			rdi
		cmp			byte [r8], 90h
		jne			.normal
		xor			rax,rax
.getnops:	inc			rax
		inc			r8
		cmp			byte [r8], 90h
		je			.getnops
		clpush			r8
		clpush			r9
		clcall0			sys.arch.panic_dec, rax, 4, rdi
		clpop			r9
		clpop			r8
		mov			ax, 'x '
		stosw
		mov			al, 90h
		jmp			.normal
		;REX
@@:		cmp			al, 40h
		jb			@f
		cmp			al, 4fh
		ja			@f
		mov			byte [.rex], al
		bt			rax, 3
		jnc			.getopcode
		mov			byte [.size], DA_QUAD
		jmp			.getopcode

@@:		cmp			al, 0d8h
		jb			@f
		cmp			al, 0dfh
		ja			@f
		;FIXME: disasm_esc
		clc
		ret
@@:		cmp			al, 0fh
		jne			.normal
		mov			al, byte [r8]
		inc			r8
		cmp			al, 0fh
		jne			.not3dnow
		;FIXME: disasm_3dnow
		add			r8, 4
		mov			rsi, .str3dnow
		call			.prtstr
		clc
		ret
.not3dnow:	xor			r9, r9
		xor			rbx, rbx
		mov			r9b, al
		shr			r9, 4
		and			r9b, 0fh
		shl			r9, 1
		add			r9, .inst0f
		xor			rcx, rcx
		mov			cx, word [r9]
		mov			r9, rcx
		or			cx, cx
		jz			.end
		add			r9, .disasm_tbl
		mov			bl, al
		and			bl, 0fh
		shl			rbx, 3
		add			r9, rbx
		jmp			.overtbl
.normal:	xor			r9, r9
		mov			r9b, al
		shl			r9, 3
		add			r9, .inst_tbl
		;has modrm?
.overtbl:	xor			rbx, rbx
		mov			dl, byte [r9+5]
		and			dl, DA_MODRM
		or			dl, dl
		jz			@f
		mov			bl, byte [r8]
		inc			r8
		call			.getaddr
@@:		xor			rdx, rdx
;al=inst, bl=regmodrm, r8=loc, r9=ip
		mov			byte [.inst], al
		mov			dx, word [r9]
		add			rdx, .disasm_tbl
		mov			rsi, rdx
		mov			cl, byte [r9+5]
		and			cl, 0Fh
		cmp			al, 0B8h
		jne			@f
		cmp			byte [.rex], 0
		je			@f
		mov			cl, DA_QUAD
@@:		mov			byte [.i_size], cl
		mov			ecx, dword [r9+2]
		and			ecx, 0ffffffh
		mov			dword [.i_mode], ecx

		;r10=f_reg(regmodrm,0)
		mov			r10, rbx
		shr			r10, 3
		and			r10, 7

		xor			rdx, rdx
		mov			dx, word [r9+6]
		add			rdx, .disasm_tbl
		cmp			rdx, .grp1
		je			.name1
		cmp			rdx, .grp2
		je			.name1
		cmp			rdx, .grp6
		je			.name1
		cmp			rdx, .grp7
		je			.name1
		cmp			rdx, .grp8
		je			.name1
		cmp			rdx, .grp9
		je			.name1
		cmp			rdx, .grpA
		je			.name1
		cmp			rdx, .grpB
		je			.name1
		cmp			rdx, .grp4
		je			.name2
		cmp			rdx, .grp5
		je			.name2
		cmp			rdx, .grp3
		jne			.nameok
		;*sizeof(instdesc)
		shl			r10, 3
		add			rdx, r10
		mov			r9, rdx
		xor			rcx, rcx
		mov			cx, word [r9]
		add			rcx, .disasm_tbl
		mov			rsi, rcx
		mov			ecx, dword [r9+2]
		and			ecx, 0ffffffh
		mov			dword [.i_mode], ecx
		jmp			.nameok
.name1:		;*sizeof(inststr)
		shl			r10, 1
		add			rdx, r10
		mov			cl, byte [r9+5]
		and			cl, 0Fh
		mov			byte [.i_size], cl
		mov			ecx, dword [r9+2]
		and			ecx, 0ffffffh
		mov			dword [.i_mode], ecx
		xor			rcx, rcx
		mov			cx, word [rdx]
		add			rcx, .disasm_tbl
		mov			rsi, rcx
		jmp			.nameok
.name2:		;*sizeof(instdesc)
		shl			r10, 3
		add			rdx, r10

		mov			r9, rdx
		xor			rcx, rcx
		mov			cx, word [r9]
		add			rcx, .disasm_tbl
		mov			rsi, rcx
		mov			cl, byte [r9+5]
		and			cl, 0Fh
		mov			byte [.i_size], cl
		mov			ecx, dword [r9+2]
		and			ecx, 0ffffffh
		mov			dword [.i_mode], ecx

.nameok:	mov			dl, byte [.i_size]
		cmp			dl, DA_SDEP
		jne			.notsdep
		mov			dl, byte [.size]
		cmp			dl, DA_WORD
		je			.prtcode
		cmp			dl, DA_LONG
		jne			.isquad
@@:		lodsb
		or			al, al
		jnz			@b
		jmp			.prtcode
.isquad:	xor			rdx, rdx
		mov			dx, word [r9+6]
		add			rdx, .disasm_tbl
		mov			rsi, rdx
		jmp			.prtcode
		;dl=i_size
.notsdep:	cmp			byte [.size], DA_WORD
		je			.prtcode
		cmp			dl, DA_NONE
		je			.nos
		mov			byte [.size], dl
.nos:		mov			dl, byte [.rex]
		and			dl, 8
		jz			.prtcode
		mov			byte [.size], DA_QUAD
.prtcode:	or			rsi, rsi
		jz			.unkcode
		cmp			byte [rsi], 'a'
		jb			.unkcode
		cmp			byte [rsi], 'z'
		ja			.unkcode
		call			.prtstr

		;arguments
		mov			rdi, r12
		add			rdi, 16
		xor			rdx, rdx

		mov			edx, dword [.i_mode]

.nextarg:	or			rdx, rdx
		jz			.end
		push			rdx
		cmp			dl, DA_E				;E
		jne			@f
.pa:		call			.prtaddr
		jmp			.argok
@@:		cmp			dl, DA_Eind				;Eind
		jne			@f
;		mov			byte [rdi], '['
;		add			rdi, 1
		call			.prtaddr
;		mov			byte [rdi], ']'
;		add			rdi, 1
		jmp			.argok
@@:		cmp			dl, DA_Ew				;Ew
		jne			@f
		mov			byte [.size], DA_WORD
		jmp			.pa
@@:		cmp			dl, DA_Eb				;Eb
		jne			@f
		mov			byte [.size], DA_BYTE
		jmp			.pa
@@:		cmp			dl, DA_R				;R
		jne			@f
		;r10=f_reg(regmodrm, rex)
		mov			r10, rbx
		shr			r10, 3
		and			r10, 7
		xor			rax, rax
		mov			al, byte [.rex]
		and			al, 4
		shl			al, 1
		add			r10, rax
		shl			r10, 3
		;reg[size][r10]
		xor			rax, rax
		mov			al, byte [.size]
		shl			rax, 3
		add			rax, .reg
		mov			rax, qword [rax]
		add			rax, r10
		mov			rsi, rax
.ps:		call			.prtstr
		jmp			.argok
@@:		cmp			dl, DA_Rw				;Rw
		jne			@f
		;r10=f_reg(regmodrm, rex)
		mov			r10, rbx
		shr			r10, 3
		and			r10, 7
		xor			rax, rax
		mov			al, byte [.rex]
		and			al, 4
		shl			al, 1
		add			r10, rax
		shl			r10, 3
		;reg[DA_WORD][r10]
		xor			rax, rax
		mov			al, DA_WORD
		shl			rax, 3
		add			rax, .reg
		mov			rax, qword [rax]
		add			rax, r10
		mov			rsi, rax
		jmp			.ps
@@:		cmp			dl, DA_Ri				;Ri
		jne			@f
		;r10=f_rm(inst, rex)
		xor			r10, r10
		mov			r10b, byte [.inst]
		and			r10, 7
		xor			rax, rax
		mov			al, byte [.rex]
		and			al, 1
		shl			al, 3
		add			r10, rax
		shl			r10, 3
		;reg[size][r10]
		xor			rax, rax
		mov			al, byte [.size]
		shl			rax, 3
		add			rax, .reg
		mov			rax, qword [rax]
		add			rax, r10
		mov			rsi, rax
		jmp			.ps
@@:		cmp			dl, DA_Ril				;Ril
		jne			@f
		;r10=f_rm(inst, rex)
		xor			r10, r10
		mov			r10b, byte [.inst]
		and			r10, 7
		xor			rax, rax
		mov			al, byte [.rex]
		and			al, 1
		shl			al, 3
		add			r10, rax
		shl			r10, 3
		;reg[DA_LONG][r10]
		xor			rax, rax
		mov			al, DA_LONG
		shl			rax, 3
		add			rax, .reg
		mov			rax, qword [rax]
		add			rax, r10
		mov			rsi, rax
		jmp			.ps
@@:		cmp			dl, DA_S				;S
		jne			@f
		mov			rsi, rbx
		shr			rsi, 3
		and			rsi, 7
		shl			rsi, 2
		add			rsi, .segreg
		jmp			.ps
@@:		cmp			dl, DA_Si				;Si
		jne			@f
		xor			r10, r10
		mov			r10b, byte [.inst]
		mov			rsi, r10
		shr			rsi, 3
		and			rsi, 7
		shl			rsi, 2
		add			rsi, .segreg
		jmp			.ps
@@:		cmp			dl, DA_A				;A
		jne			@f
		;reg[size][0]
		xor			rax, rax
		mov			al, byte [.size]
		shl			rax, 3
		add			rax, .reg
		mov			rax, qword [rax]
		mov			rsi, rax
		jmp			.ps
@@:		cmp			dl, DA_BX				;BX
		jne			@f
		;reg[saddr+2][3]
		xor			rax, rax
		mov			al, byte [.saddr]
		add			al, 2
		shl			rax, 3
		add			rax, .reg
		mov			rax, qword [rax]
		add			rax, 3*8
		mov			rsi, rax
		cmp			byte [.seg], 0
		jz			.ps
		mov			al, byte [.seg]
		mov			byte [rdi], al
		mov			byte [rdi+1], 's'
		mov			byte [rdi+2], ':'
		add			rdi, 3
		jmp			.ps
@@:		cmp			dl, DA_CL				;CL
		jne			@f
		;reg[saddr+2][1]
		xor			rax, rax
		mov			al, byte [.saddr]
		add			al, 2
		shl			rax, 3
		add			rax, .reg
		mov			rax, qword [rax]
		add			rax, 8
		mov			rsi, rax
		jmp			.ps
@@:		cmp			dl, DA_DX				;DX
		jne			@f
		mov			rsi, .reg1+16
		jmp			.ps
@@:		cmp			dl, DA_SI				;SI
		jne			@f
		;reg[saddr+2][6]
		xor			rax, rax
		mov			al, DA_WORD
		cmp			byte [.size], DA_WORD
		je			.noqu0
		mov			al, DA_QUAD
.noqu0:		shl			rax, 3
		add			rax, .reg
		mov			rax, qword [rax]
		add			rax, 6*8
.prtreg0:	push			rax
		mov			rsi, .sizestr
		call			.prtstr
		add			rdi, 1
		pop			rsi
		cmp			byte [.seg], 0
		jz			.noseg0
		mov			al, byte [.seg]
		mov			byte [rdi], al
		mov			byte [rdi+1], 's'
		mov			byte [rdi+2], ':'
		add			rdi, 3
.noseg0:	mov			byte [rdi], '['
		add			rdi, 1
		call			.prtstr
		mov			byte [rdi], ']'
		add			rdi, 1
		jmp			.argok
@@:		cmp			dl, DA_DI				;DI
		jne			@f
		;reg[size][7]
		xor			rax, rax
		mov			al, DA_WORD
		cmp			byte [.size], DA_WORD
		je			.noqu1
		mov			al, DA_QUAD
.noqu1:		shl			rax, 3
		add			rax, .reg
		mov			rax, qword [rax]
		add			rax, 7*8
		jmp			.prtreg0
@@:		cmp			dl, DA_CR				;CR
		jne			@f
		mov			dl, 'C'
		;r10=f_reg(regmodrm, rex)
.pr:		mov			r10, rbx
		shr			r10, 3
		and			r10, 7
		xor			rax, rax
		mov			al, byte [.rex]
		and			al, 4
		shl			al, 1
		add			r10, rax
		mov			byte [rdi], dl
		mov			byte [rdi+1], 'R'
		mov			byte [rdi+3], r10b
		add			byte [rdi+3], '0'
		add			rdi, 4
		jmp			.argok
@@:		cmp			dl, DA_DR				;DR
		jne			@f
		mov			dl, 'D'
		jmp			.pr
@@:		cmp			dl, DA_TR
		jne			@f
		mov			dl, 'T'
		jmp			.pr
@@:		cmp			dl, DA_I				;I
		jne			@f
		cmp			byte [.size], DA_WORD
		je			.noqu
		cmp			byte [.size], DA_LONG
		je			.noqu
		cmp			bl, 0
		jne			.noqu
		mov			rax, qword [r8]
		add			r8, 8
		jmp			.noget
.noqu:		call			.getim
.noget:		call			.prtpadhex
		jmp			.argok
@@:		cmp			dl, DA_Ib				;Ib
		jne			@f
		xor			rax, rax
		mov			al, byte [r8]
		mov			rcx, 4
		clpush			r8
		clpush			r9
		clcall0			sys.arch.panic_hex, rax, 8, rdi
		clpop			r9
		clpop			r8
		inc			r8
		jmp			.argok
@@:		cmp			dl, DA_Iw				;Iw
		jne			@f
		xor			rax, rax
		mov			ax, word [r8]
		call			.prtpadhex
		add			r8, 2
		jmp			.argok
@@:		cmp			dl, DA_Id				;Id
		jne			@f
		xor			rax, rax
		mov			eax, dword [r8]
		call			.prtpadhex
		add			r8, 4
		jmp			.argok
@@:		cmp			dl, DA_Iq				;Iq
		jne			@f
		mov			rax, qword [r8]
		call			.prtpadhex
		add			r8, 8
		jmp			.argok
@@:		cmp			dl, DA_O				;O
		jne			@f
		xor			rax, rax
		cmp			byte [.saddr], 1
		je			.sh
		mov			eax, dword [r8]
		add			r8, 4
		call			.prtpadhex
		jmp			.argok
.sh:		mov			ax, word [r8]
		add			r8, 2
		call			.prtpadhex
		jmp			.argok
@@:		cmp			dl, DA_Db				;Db
		jne			@f
		xor			rax, rax
		movsx			rax, byte [r8]
		inc			r8
		add			rax, r8
		push			rbx
		mov			rbx, 0FFFFFFFFh
		and			rax, rbx
		call			.setlink
		pop			rbx
		call			.prtpadhex
		call			.prtsym
		jmp			.argok
@@:		cmp			dl, DA_Dl				;Dl
		jne			@f
		call			.getim
		add			rax, r8
		push			rbx
		mov			rbx, 0FFFFFFFFh
		and			rax, rbx
		pop			rbx
		call			.setlink
		call			.prtpadhex
		call			.prtsym
		jmp			.argok
@@:		cmp			dl, DA_o1				;o1
		jne			@f
		mov			byte [rdi], '1'
		add			rdi, 1
		jmp			.argok
@@:		cmp			dl, DA_o3				;o3
		jne			@f
		mov			byte [rdi], '3'
		add			rdi, 1
		jmp			.argok
@@:		cmp			dl, DA_OS				;SO
		jne			@f
		call			.getim
		call			.prtpadhex
		mov			byte [rdi], ':'
		add			rdi, 1
		mov			ax, word [r8]
		clpush			r8
		clpush			r9
		clcall0			sys.arch.panic_hex, rax, 16, rdi
		clpop			r9
		clpop			r8
		jmp			.argok
@@:		jmp			.unkcode

.argok:		pop			rdx
		shr			rdx, 8
		or			rdx, rdx
		jz			.end
		mov			word [rdi], ', '
		add			rdi, 2
		jmp			.nextarg
;writes rax to linkptr once
.setlink:	push			rbx
		xor			rbx, rbx
		cmp			qword [sys.arch.panic.linkptr], rbx
		jnz			.nolink
		mov			qword [sys.arch.panic.linkptr], rax
		mov			byte [rdi], 2
		inc			rdi
.nolink:	pop			rbx
		ret

.prtsym:	push			rdi
		push			r8
		push			r9
		push			r10
		mov			byte [rdi], 4
		inc			rdi
		mov			byte [rdi], ' '
		inc			rdi
		clcall0			sys.arch.panic_ip2idx, rax
		clcall0			sys.arch.panic_idx2str, r8, r9, 0
		xor			al, al
		stosb
		pop			r10
		pop			r9
		pop			r8
		pop			rdi
.next255:	inc			rdi
		cmp			byte [rdi], 255
		jne			.not255
		mov			byte [rdi], ' '
.not255:	cmp			byte [rdi], 0
		jnz			.next255
		ret

;reads and immediate value (disp or real imm)
.getim:		xor			rax, rax
		xor			rcx, rcx
		cmp			byte [.size], DA_WORD
		je			.forceword
		mov			cl, byte [.i_size]
		cmp			cl, DA_NONE
		jne			@f
.forceword:	mov			cl, byte [.size]
@@:		cmp			cl, DA_BYTE
		jne			@f
		mov			al, byte [r8]
		mov			rcx, 8
		inc			r8
		ret
@@:		cmp			cl, DA_WORD
		jne			@f
		mov			ax, word [r8]
		mov			rcx, 16
		add			r8, 2
		ret
@@:		cmp			cl, DA_LONG
		jne			@f
		mov			eax, dword [r8]
		mov			rcx, 32
		add			r8, 4
		ret
@@:		mov			rax, qword [r8]
		mov			rcx, 64
		add			r8, 8
		ret
.unkcode:	mov			rsi, .unkmnemonic
		call			.prtstr
.end:
.disasmend2:	cmp			byte [sys.arch.panic.disasm], 0
		jnz			.nodump0
                mov                     rsi, qword [.disasmstart]
		mov			rdi, qword [.origout]
		mov			rax, '        '
		mov			rbx, rdi
		stosq
		stosq
.disasmend3:    clc
                lodsb
                jc                      .disasmend
                clpush                  rsi
		clpush			rax
		clpush			rbx
		clpush			r8
		clpush			r9
		clcall0			sys.arch.panic_hex, rax, 8, rdi
		mov			al, ' '
		stosb
		clpop			r9
		clpop			r8
		clpop			rbx
		clpop			rax
                clpop                   rsi
		cmp			al, 14
		jb			.skip
		cmp			al, 0FFh
		jb			.noskip
.skip:		mov			al, '.'
.noskip:	mov			byte [rbx], al
		inc			rbx
                cmp                     rsi, r8
                jb                      .disasmend3
.nodump0:	;jmp			.endok
.endok:         clc
.disasmend:     mov                     byte [rdi], 0
		mov			r9, rdi
		ret
.notmapped:	mov                     rsi, sys.arch.panic.notmappedstr
		mov			rdi, qword [.origout]
@@:		lodsb
		stosb
		or			al, al
		jnz			@b
                mov			r9, rdi
		add			r8, PAGESIZE
		and			r8d, 0FFFFFFFFh-(PAGESIZE-1)
		stc
		ret

.prtstr:	cmp			byte [sys.arch.panic.disasm], 0
		jz			@f
		lodsb
		or			al, al
		jz			@f
		stosb
		jmp			.prtstr
@@:		ret

;function to parse an address
.getaddr:	xor			rcx, rcx
		mov			qword [.addr_disp], rcx
		mov			qword [.addr_base], rcx
		mov			qword [.addr_idx], rcx
		mov			byte [.addr_ss], cl
		;rcx=size
		mov			cl, byte [.size]
		;r10=mod
@@:		mov			r10w, bx
		shr			r10b, 6
		and			r10, 3
		;r11=rm
		xor			r11, r11
		xor			rdx, rdx
		mov			r11w, bx
		and			r11, 7
		xor			rdx, rdx
		mov			dl, byte [.rex]
		and			dl, 1
		shl			rdx, 3
		add			r11, rdx

		cmp			r10b, 3
		jne			@f
		mov			byte [.addr_reg], 1
		mov			byte [.addr_disp], r11b
		ret
@@:		mov			byte [.addr_reg], 0
		mov			qword [.addr_idx], 0

		cmp			r11, 4
		je			@f
		cmp			r11, 12
		jne			.addr1
		;dh=sib
@@:		mov			al, byte [r8]
		inc			r8
		;sib_ss
		mov			dl, al
		shr			dl, 6
		mov			byte [.addr_ss], dl
		;sib_base
		mov			dl, byte [.rex]
		and			dl, 1
		shl			dl, 3
		mov			r11b, al
		and			r11b, 7
		add			r11b, dl
		;sib_idx
		mov			dl, byte [.rex]
		and			dl, 2
		shl			dl, 2
		shr			al, 3
		and			al, 7
		add			dl, al
		;addr_idx
		cmp			dl, 4
		je			.addr1
		;reg[size][idx]
		xor			dh, dh
		shl			dx, 3
		;mov			rax, rcx
		xor			rax, rax
		mov			al, DA_QUAD
		shl			rax, 3
		add			rax, .reg
		mov			rax, qword [rax]
		add			ax, dx
		mov			qword [.addr_idx], rax
.addr1:		cmp			r10b, 0
		je			.mod0
		cmp			r10b, 1
		je			.mod1
		mov			eax, dword [r8]
		add			r8, 4

		mov			dword [.addr_disp], eax
		mov			dword [.addr_disp+4], 0
		;reg[size][rm]
		xor			dh, dh
		mov			dl, r11b
		shl			dl, 3
		mov			rax, rcx
		shl			rax, 3
		add			rax, .reg
		mov			rax, qword [rax]
		add			ax, dx
		mov			qword [.addr_base], rax
		jmp			.addrok
.mod0:		cmp			r11b, 5
		jne			@f
		mov			eax, dword [r8]
		add			r8, 4
		mov			dword [.addr_disp], eax
		mov			dword [.addr_disp+4], 0
		jmp			.addrok
@@:		mov			qword [.addr_disp], 0
		;reg[size][rm]
		xor			dh, dh
		mov			dl, r11b
		shl			dl, 3
		xor			rax, rax
		mov			al, DA_QUAD
		shl			rax, 3
		add			rax, .reg
		mov			rax, qword [rax]
		add			ax, dx
		mov			qword [.addr_base], rax
		jmp			.addrok
.mod1:		mov			al, byte [r8]
		inc			r8
		mov			byte [.addr_disp], al
		;reg[QUAD][rm]
		xor			dh, dh
		mov			dl, r11b
		shl			dl, 3
		xor			rax, rax
		mov			al, DA_QUAD
		shl			rax, 3
		add			rax, .reg
		mov			rax, qword [rax]
		add			ax, dx
		mov			qword [.addr_base], rax
.addrok:	ret
;function to print out an address
.prtaddr:	cmp			byte [.addr_reg], 0
		jz			@f
		;reg[size][disp]
		xor			rax, rax
		xor			rdx, rdx
		mov			dl, byte [.addr_disp]
		shl			dl, 3
;		mov			al, byte [.i_size]
		mov			al, byte [.size]
		shl			rax, 3
		add			rax, .reg
		mov			rax, qword [rax]
		add			rax, rdx
		mov			rsi, rax
		call			.prtstr
		ret
@@:		xor			rdx, rdx
		mov			dl, byte [.size]
		shl			rdx, 3
		add			rdx, .sizestr
		mov			rsi, rdx
		call			.prtstr
		mov			ax, '  '
		stosw

		cmp			byte [.seg], 0
		jz			@f
		mov			al, byte [.seg]
		mov			byte [rdi], al
		mov			byte [rdi+1], 's'
		mov			byte [rdi+2], ':'
		add			rdi, 3
		;base
@@:		mov			byte [rdi], '['
		add			rdi, 1
		mov			rsi, qword [.addr_base]
		cmp			rsi, 0
		jnz			@f
		;mov			rsi, .ripreg
		mov			rax, r8
		add			rax, qword [.addr_disp]
		mov			rsi, 0ffffffffh
		and			rax, rsi
		jmp			.prdisp
@@:		call			.prtstr
		;idx
.idx:		mov			rsi, qword [.addr_idx]
		cmp			rsi, 0
		jz			@f
		mov			byte [rdi], '+'
		add			rdi, 1
		call			.prtstr
		push			rcx
		mov			cl, byte [.addr_ss]
		xor			rax, rax
		inc			rax
		shl			rax, cl
		pop			rcx
		cmp			rax, 1
		je			@f
		mov			byte [rdi], '*'
		add			rdi, 1
		call			.prtpadhex
@@:		mov			rax, qword [.addr_disp]
		or			rax, rax
		jz			.prtend
		cmp			byte [.i_size], DA_BYTE
		jne			.notbyte
		cmp			al, 80h
		jb			.plus
		neg			al
		and			rax, 0ffh
		jmp			.neg
.notbyte:	cmp			byte [.i_size], DA_WORD
		jne			.notword
		cmp			ax, 8000h
		jb			.plus
		neg			ax
		and			rax, 0ffffh
		jmp			.neg
.notword:	cmp			eax, 80000000h
		jb			.plus
		neg			eax
		mov			rsi, 0ffffffffh
		and			rax, rsi
		mov			esi, eax
		xor			rax, rax
		mov			eax, esi
.neg:		mov			byte [rdi], '-'
		jmp			@f
.plus:		mov			byte [rdi], '+'
@@:		add			rdi, 1
.prdisp:	call			.prtpadhex
.prtend:	mov			byte [rdi], ']'
		add			rdi, 1
		clc
		ret

.prtpadhex:	push			rax
		push			r9
		mov			rcx, 64
		mov			r9, rax
		shr			r9, 32
		or			r9, r9
		jnz			@f
		mov			rcx, 32
		mov			r9, rax
		shr			r9, 16
		or			r9, r9
		jnz			@f
		mov			rcx, 16
		mov			r9, rax
		shr			r9, 8
		or			r9, r9
		jnz			@f
		mov			rcx, 8
@@:
		push			r8
		clcall0			sys.arch.panic_hex, rax, rcx, rdi
		pop			r8
		pop			r9
		pop			rax
		ret
