;sizes
DA_BYTE         =                       0
DA_WORD         =                       1
DA_LONG         =                       2
DA_QUAD         =                       3
DA_SNGL         =                       4
DA_DBLR         =                       5
DA_EXTR         =                       6
DA_SDEP         =                       7
DA_NONE         =                       8
DA_MODRM        =                       80h

;addressing
INVALID         =                       0
DA_E            =                       1
DA_Eind         =                       2
DA_Ew           =                       3
DA_Eb           =                       4
DA_R            =                       5
DA_Rw           =                       6
DA_Ri           =                       7
DA_S            =                       8
DA_Si           =                       9
DA_A            =                       10
DA_BX           =                       11
DA_CL           =                       12
DA_DX           =                       13
DA_SI           =                       14
DA_DI           =                       15
DA_CR           =                       16
DA_DR           =                       17
DA_TR           =                       18
DA_I            =                       19
DA_Ib           =                       20
DA_Iw           =                       21
DA_Id           =                       22
DA_Iq           =                       23
DA_O            =                       24
DA_Db           =                       25
DA_Dl           =                       26
DA_o1           =                       27
DA_o3           =                       28
DA_OS           =                       29
DA_ST           =                       30
DA_STI          =                       31
DA_X            =                       32
DA_XA           =                       33
DA_Ril          =                       34
DA2_A_Ri        =                       DA_A*256+DA_Ri
DA2_I_Ri        =                       DA_I*256+DA_Ri
DA2_Ib_Ri       =                       DA_Ib*256+DA_Ri
DA2_Iq_Ib       =                       DA_Iq*256+DA_Ib
DA2_E_R         =                       DA_E*256+DA_R
DA2_E_A         =                       DA_E*256+DA_A
DA2_O_A         =                       DA_O*256+DA_A
DA2_A_O         =                       DA_A*256+DA_O
DA2_Eb_R        =                       DA_Eb*256+DA_R
DA2_Ew_R        =                       DA_Ew*256+DA_R
DA2_CL_E        =                       DA_CL*256+DA_E
DA2_R_E         =                       DA_R*256+DA_E
DA2_I_E         =                       DA_I*256+DA_E
DA2_Ib_E        =                       DA_Ib*256+DA_E
DA2_I_Eind      =                       DA_I*256+DA_Eind
DA2_I_A         =                       DA_I*256+DA_A
DA2_Ib_A        =                       DA_Ib*256+DA_A
DA2_A_Ib        =                       DA_A*256+DA_Ib
DA2_DX_A        =                       DA_DX*256+DA_A
DA2_A_DX        =                       DA_A*256+DA_DX
DA2_Ib_E        =                       DA_Ib*256+DA_E
DA2_CR_E        =                       DA_CR*256+DA_E
DA2_DR_E        =                       DA_DR*256+DA_E
DA2_TR_E        =                       DA_DR*256+DA_E
DA2_E_CR        =                       DA_E*256+DA_CR
DA2_E_DR        =                       DA_E*256+DA_DR
DA2_E_TR        =                       DA_E*256+DA_TR
DA2_S_Ew        =                       DA_S*256+DA_Ew
DA2_Ew_S        =                       DA_Ew*256+DA_S
DA2_STI_ST      =                       DA_STI*256+DA_ST
DA2_ST_STI      =                       DA_ST*256+DA_STI
DA2_SI_DI       =                       DA_SI*256+DA_DI
DA2_DX_DI       =                       DA_DX*256+DA_DI
DA2_SI_DX       =                       DA_SI*256+DA_DX
DA2_o1_E        =                       DA_o1*256+DA_E
DA3_Ib_R_E      =                       DA_Ib*65536+DA_R*256+DA_E
DA3_CL_R_E      =                       DA_CL*65536+DA_R*256+DA_E
DA3_Ib_E_R      =                       DA_Ib*65536+DA_E*256+DA_R
DA3_CL_E_R      =                       DA_CL*65536+DA_E*256+DA_R
DA3_I_E_R       =                       DA_I*65536+DA_E*256+DA_R

macro           instdesc                name, size, mode, ext
{
if defined .mne_#name
                dw                      .mne_#name-.disasm_tbl
else
		dw			0
end if
                dd                      mode+((size) shl 24)
if defined .mne_#ext
                dw                      .mne_#ext-.disasm_tbl
else
if ~ ext eq 0
		dw			ext-.disasm_tbl
else
		dw			0
end if
end if
}

macro           inststr                 name
{
if defined .mne_#name
                dw                      .mne_#name-.disasm_tbl
else
                dw                      0
end if
}

.disasm_tbl:
		nop
.mne_adc:       db              "adc",0
.mne_add:       db              "add",0
.mne_and:       db              "and",0
.mne_bsf:       db              "bsf",0
.mne_bsr:       db              "bsr",0
.mne_bswap:     db              "bswap",0
.mne_bt:        db              "bt",0
.mne_btc:       db              "btc",0
.mne_btr:       db              "btr",0
.mne_bts:       db              "bts",0
.mne_call:      db              "call",0
.mne_cbw:       db              "cbw",0,"cwde",0
.mne_cdqe:      db              "cdqe",0
.mne_clc:       db              "clc",0
.mne_cld:       db              "cld",0
.mne_cli:       db              "cli",0
.mne_clts:      db              "clts",0
.mne_cmc:       db              "cmc",0
.mne_cmp:       db              "cmp",0
.mne_cmpsb:     db              "cmpsb",0
.mne_cmpsd:     db              "cmpsd",0
.mne_cmpxchg8b: db              "cmpxchg8b",0
.mne_cmpxchg:   db              "cmpxchg",0
.mne_cpuid:     db              "cpuid",0
.mne_cqo:       db              "cqo",0
.mne_cwd:       db              "cwd",0,"cdq",0
.mne_db_0D6h:   db              "db 0D6h",0
.mne_dec:       db              "dec",0
.mne_div:       db              "div",0
.mne_enter:     db              "enter",0
.mne_f2xm1:     db              "f2xm1",0
.mne_fabs:      db              "fabs",0
.mne_fadd:      db              "fadd",0
.mne_faddp:     db              "faddp",0
.mne_fbld:      db              "fbld",0
.mne_fbstp:     db              "fbstp",0
.mne_fchs:      db              "fchs",0
.mne_fcom:      db              "fcom",0
.mne_fcomp:     db              "fcomp",0
.mne_fcompp:    db              "fcompp",0
.mne_fcos:      db              "fcos",0
.mne_fdecstp:   db              "fdecstp",0
.mne_fdiv:      db              "fdiv",0
.mne_fdivp:     db              "fdivp",0
.mne_fdivr:     db              "fdivr",0
.mne_fdivrp:    db              "fdivrp",0
.mne_ffree:     db              "ffree",0
.mne_fiadd:     db              "fiadd",0
.mne_ficom:     db              "ficom",0
.mne_ficomp:    db              "ficomp",0
.mne_fidiv:     db              "fidiv",0
.mne_fidivr:    db              "fidivr",0
.mne_fild:      db              "fild",0
.mne_fimul:     db              "fimul",0
.mne_fincstp:   db              "fincstp",0
.mne_fist:      db              "fist",0
.mne_fistp:     db              "fistp",0
.mne_fisub:     db              "fisub",0
.mne_fisubr:    db              "fisubr",0
.mne_fld1:      db              "fld1",0
.mne_fld:       db              "fld",0
.mne_fldcw:     db              "fldcw",0
.mne_fldenv:    db              "fldenv",0
.mne_fldl2e:    db              "fldl2e",0
.mne_fldl2t:    db              "fldl2t",0
.mne_fldlg2:    db              "fldlg2",0
.mne_fldln2:    db              "fldln2",0
.mne_fldpi:     db              "fldpi",0
.mne_fldz:      db              "fldz",0
.mne_fmul:      db              "fmul",0
.mne_fmulp:     db              "fmulp",0
.mne_fnclex:    db              "fnclex",0
.mne_fndisi:    db              "fndisi",0
.mne_fneni:     db              "fneni",0
.mne_fninit:    db              "fninit",0
.mne_fnop:      db              "fnop",0
.mne_fnsave:    db              "fnsave",0
.mne_fnstcw:    db              "fnstcw",0
.mne_fnstenv:   db              "fnstenv",0
.mne_fnstsw:    db              "fnstsw",0
.mne_fpatan:    db              "fpatan",0
.mne_fprem1:    db              "fprem1",0
.mne_fprem:     db              "fprem",0
.mne_fptan:     db              "fptan",0
.mne_frndint:   db              "frndint",0
.mne_frstor:    db              "frstor",0
.mne_fscale:    db              "fscale",0
.mne_fsetpm:    db              "fsetpm",0
.mne_fsin:      db              "fsin",0
.mne_fsincos:   db              "fsincos",0
.mne_fsqrt:     db              "fsqrt",0
.mne_fst:       db              "fst",0
.mne_fstp:      db              "fstp",0
.mne_fsub:      db              "fsub",0
.mne_fsubp:     db              "fsubp",0
.mne_fsubr:     db              "fsubr",0
.mne_fsubrp:    db              "fsubrp",0
.mne_ftst:      db              "ftst",0
.mne_fucom:     db              "fucom",0
.mne_fucomp:    db              "fucomp",0
.mne_fucompp:   db              "fucompp",0
.mne_fxam:      db              "fxam",0
.mne_fxch:      db              "fxch",0
.mne_fxrstor:   db              "fxrstor",0
.mne_fxsave:    db              "fxsave",0
.mne_fxtract:   db              "fxtract",0
.mne_fyl2x:     db              "fyl2x",0
.mne_fyl2xp1:   db              "fyl2xp1",0
.mne_hlt:       db              "hlt",0
.mne_idiv:      db              "idiv",0
.mne_imul:      db              "imul",0
.mne_in:        db              "in",0
.mne_inc:       db              "inc",0
.mne_ins:       db              "ins",0
.mne_int:       db              "int",0
.mne_invd:      db              "invd",0
.mne_invlpg:    db              "invlpg",0
.mne_iret:      db              "iret",0
.mne_jb:        db              "jb",0
.mne_jbe:       db              "jbe",0
.mne_jcxz:      db              "jcxz",0,"jecxz",0
.mne_jl:        db              "jl",0
.mne_jle:       db              "jle",0
.mne_jmp:       db              "jmp",0
.mne_jnb:       db              "jnb",0
.mne_jnbe:      db              "jnbe",0
.mne_jnl:       db              "jnl",0
.mne_jnle:      db              "jnle",0
.mne_jno:       db              "jno",0
.mne_jnp:       db              "jnp",0
.mne_jns:       db              "jns",0
.mne_jnz:       db              "jnz",0
.mne_jo:        db              "jo",0
.mne_jp:        db              "jp",0
.mne_jrcxz:     db              "jrcxz",0
.mne_js:        db              "js",0
.mne_jz:        db              "jz",0
.mne_lahf:      db              "lahf",0
.mne_lar:       db              "lar",0
.mne_lcall:     db              "lcall",0
.mne_lea:       db              "lea",0
.mne_leave:     db              "leave",0
.mne_lfs:       db              "lfs",0
.mne_lgdt:      db              "lgdt",0
.mne_lgs:       db              "lgs",0
.mne_lidt:      db              "lidt",0
.mne_ljmp:      db              "ljmp",0
.mne_lldt:      db              "lldt",0
.mne_lmsw:      db              "lmsw",0
.mne_lodsb:     db              "lodsb",0
.mne_lodsw:     db              "lodsw",0
.mne_lodsd:     db              "lodsd",0
.mne_loop:      db              "loop",0
.mne_loope:     db              "loope",0
.mne_loopne:    db              "loopne",0
.mne_lret:      db              "lret",0
.mne_lsl:       db              "lsl",0
.mne_lss:       db              "lss",0
.mne_ltr:       db              "ltr",0
.mne_mov:       db              "mov",0
.mne_movsb:     db              "movsb",0
.mne_movsd:     db              "movsd",0
.mne_movsw:     db              "movsw",0
.mne_movsxd:    db              "movsxd",0
.mne_movzb:     db              "movzb",0
.mne_movzw:     db              "movzw",0
.mne_mul:       db              "mul",0
.mne_neg:       db              "neg",0
.mne_nop:       db              "nop",0
.mne_not:       db              "not",0
.mne_or:        db              "or",0
.mne_out:       db              "out",0
.mne_outs:      db              "outs",0
.mne_pop:       db              "pop",0
.mne_popf:      db              "popf",0
.mne_push:      db              "push",0
.mne_pushf:     db              "pushf",0
.mne_rcl:       db              "rcl",0
.mne_rcr:       db              "rcr",0
.mne_rdmsr:     db              "rdmsr",0
.mne_rdpmc:     db              "rdpmc",0
.mne_rdtsc:     db              "rdtsc",0
.mne_ret:       db              "ret",0
.mne_rol:       db              "rol",0
.mne_ror:       db              "ror",0
.mne_sahf:      db              "sahf",0
.mne_sal:       db              "sal",0
.mne_sar:       db              "sar",0
.mne_sbb:       db              "sbb",0
.mne_scasb:     db              "scasb",0
.mne_scasd:     db              "scasd",0
.mne_setb:      db              "setb",0
.mne_setbe:     db              "setbe",0
.mne_setl:      db              "setl",0
.mne_setle:     db              "setle",0
.mne_setnb:     db              "setnb",0
.mne_setnbe:    db              "setnbe",0
.mne_setnl:     db              "setnl",0
.mne_setnle:    db              "setnle",0
.mne_setno:     db              "setno",0
.mne_setnp:     db              "setnp",0
.mne_setns:     db              "setns",0
.mne_setnz:     db              "setnz",0
.mne_seto:      db              "seto",0
.mne_setp:      db              "setp",0
.mne_sets:      db              "sets",0
.mne_setz:      db              "setz",0
.mne_sgdt:      db              "sgdt",0
.mne_shl:       db              "shl",0
.mne_shld:      db              "shld",0
.mne_shr:       db              "shr",0
.mne_shrd:      db              "shrd",0
.mne_sidt:      db              "sidt",0
.mne_sldt:      db              "sldt",0
.mne_smsw:      db              "smsw",0
.mne_stc:       db              "stc",0
.mne_std:       db              "std",0
.mne_sti:       db              "sti",0
.mne_stosb:     db              "stosb",0
.mne_stosw:     db              "stosw",0
.mne_stosd:     db              "stosd",0
.mne_str:       db              "str",0
.mne_sub:       db              "sub",0
.mne_sysret:	db		"sysret",0
.mne_test:      db              "test",0
.mne_verr:      db              "verr",0
.mne_verw:      db              "verw",0
.mne_wait:      db              "wait",0
.mne_wbinvd:    db              "wbinvd",0
.mne_wrmsr:     db              "wrmsr",0
.mne_xadd:      db              "xadd",0
.mne_xchg:      db              "xchg",0
.mne_xcryptcbc: db              "xcrypt-cbc",0
.mne_xcryptcfb: db              "xcrypt-cfb",0
.mne_xcryptecb: db              "xcrypt-ecb",0
.mne_xcryptofb: db              "xcrypt-ofb",0
.mne_xlat:      db              "xlat",0
.mne_xor:       db              "xor",0
.mne_xstorerng: db              "xstore-rng",0

		align		8
.grp1:		inststr		add
		inststr		or
		inststr		adc
		inststr		sbb
		inststr		and
		inststr		sub
		inststr		xor
		inststr		cmp

.grp2:		inststr		rol
		inststr		ror
		inststr		rcl
		inststr		rcr
		inststr		shl
		inststr		shr
		inststr		sal
		inststr		sar

.grp3:		instdesc	 test, DA_NONE+DA_MODRM, DA2_I_E, 0
		instdesc	 test, DA_NONE+DA_MODRM, DA2_I_E, 0
		instdesc	 not, DA_NONE+DA_MODRM, DA_E, 0
		instdesc	 neg, DA_NONE+DA_MODRM, DA_E, 0
		instdesc	 mul, DA_NONE+DA_MODRM, DA2_E_A, 0
		instdesc	 imul, DA_NONE+DA_MODRM, DA2_E_A, 0
		instdesc	 div, DA_NONE+DA_MODRM, DA2_E_A, 0
		instdesc	 idiv, DA_NONE+DA_MODRM, DA2_E_A, 0

.grp4:		instdesc	 inc, DA_BYTE+DA_MODRM, DA_E, 0
		instdesc	 dec, DA_BYTE+DA_MODRM, DA_E, 0
		instdesc	 0, DA_NONE+DA_MODRM, 0, 0
		instdesc	 0, DA_NONE+DA_MODRM, 0, 0
		instdesc	 0, DA_NONE+DA_MODRM, 0, 0
		instdesc	 0, DA_NONE+DA_MODRM, 0, 0
		instdesc	 0, DA_NONE+DA_MODRM, 0, 0
		instdesc	 0, DA_NONE+DA_MODRM, 0, 0

.grp5:		instdesc	 inc, DA_LONG+DA_MODRM, DA_E, 0
		instdesc	 dec, DA_LONG+DA_MODRM, DA_E, 0
		instdesc	 call, DA_QUAD+DA_MODRM, DA_Eind, 0
		instdesc	 lcall, DA_NONE+DA_MODRM, DA_Eind, 0
		instdesc	 jmp, DA_NONE+DA_MODRM, DA_Eind, 0
		instdesc	 ljmp, DA_NONE+DA_MODRM, DA_Eind, 0
		instdesc	 push, DA_QUAD+DA_MODRM, DA_E, 0
		instdesc	 0, DA_NONE+DA_MODRM, 0, 0

.grp6:		inststr		sldt
		inststr		str
		inststr		lldt
		inststr		ltr
		inststr		verr
		inststr		verw
		inststr		0
		inststr		0

.grp7:		inststr		sgdt
		inststr		sidt
		inststr		lgdt
		inststr		lidt
		inststr		smsw
		inststr		0
		inststr		lmsw
		inststr		invlpg

.grp8:		inststr		0
		inststr		0
		inststr		0
		inststr		0
		inststr		bt
		inststr		bts
		inststr		btr
		inststr		btc

.grp9:		inststr		fxsave
		inststr		fxrstor
		inststr		0
		inststr		0
		inststr		0
		inststr		0
		inststr		0
		inststr		0

.grpA:		inststr		0
		inststr		cmpxchg8b
		inststr		0
		inststr		0
		inststr		0
		inststr		0
		inststr		0
		inststr		0

.grpB:		inststr		xstorerng
		inststr		xcryptecb
		inststr		xcryptcbc
		inststr		0
		inststr		xcryptcfb
		inststr		xcryptofb
		inststr		0
		inststr		0

.inst0f0:	instdesc	 0, DA_NONE+DA_MODRM, DA_Ew, .grp6
		instdesc	 0, DA_NONE+DA_MODRM, DA_Ew, .grp7
		instdesc	 lar, DA_LONG+DA_MODRM, DA2_E_R, 0
		instdesc	 lsl, DA_LONG+DA_MODRM, DA2_E_R, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 clts, DA_NONE, 0, 0
		instdesc	 sysret, DA_NONE, 0, 0

		instdesc	 invd, DA_NONE, 0, 0
		instdesc	 wbinvd, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0

.inst0f2:	instdesc	 mov, DA_LONG+DA_MODRM, DA2_CR_E, 0
		instdesc	 mov, DA_LONG+DA_MODRM, DA2_DR_E, 0
		instdesc	 mov, DA_LONG+DA_MODRM, DA2_E_CR, 0
		instdesc	 mov, DA_LONG+DA_MODRM, DA2_E_DR, 0
		instdesc	 mov, DA_LONG+DA_MODRM, DA2_TR_E, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 mov, DA_LONG+DA_MODRM, DA2_E_TR, 0
		instdesc	 0, DA_NONE, 0, 0

		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0

.inst0f3:	instdesc	 wrmsr, DA_NONE, 0, 0
		instdesc	 rdtsc, DA_NONE, 0, 0
		instdesc	 rdmsr, DA_NONE, 0, 0
		instdesc	 rdpmc, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0

		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0

.inst0f8:	instdesc	 jo, DA_NONE, DA_Dl, 0
		instdesc	 jno, DA_NONE, DA_Dl, 0
		instdesc	 jb, DA_NONE, DA_Dl, 0
		instdesc	 jnb, DA_NONE, DA_Dl, 0
		instdesc	 jz, DA_NONE, DA_Dl, 0
		instdesc	 jnz, DA_NONE, DA_Dl, 0
		instdesc	 jbe, DA_NONE, DA_Dl, 0
		instdesc	 jnbe, DA_NONE, DA_Dl, 0

		instdesc	 js, DA_NONE, DA_Dl, 0
		instdesc	 jns, DA_NONE, DA_Dl, 0
		instdesc	 jp, DA_NONE, DA_Dl, 0
		instdesc	 jnp, DA_NONE, DA_Dl, 0
		instdesc	 jl, DA_NONE, DA_Dl, 0
		instdesc	 jnl, DA_NONE, DA_Dl, 0
		instdesc	 jle, DA_NONE, DA_Dl, 0
		instdesc	 jnle, DA_NONE, DA_Dl, 0

.inst0f9:	instdesc	 seto, DA_NONE+DA_MODRM, DA_Eb, 0
		instdesc	 setno, DA_NONE+DA_MODRM, DA_Eb, 0
		instdesc	 setb, DA_NONE+DA_MODRM, DA_Eb, 0
		instdesc	 setnb, DA_NONE+DA_MODRM, DA_Eb, 0
		instdesc	 setz, DA_NONE+DA_MODRM, DA_Eb, 0
		instdesc	 setnz, DA_NONE+DA_MODRM, DA_Eb, 0
		instdesc	 setbe, DA_NONE+DA_MODRM, DA_Eb, 0
		instdesc	 setnbe, DA_NONE+DA_MODRM, DA_Eb, 0

		instdesc	 sets, DA_NONE+DA_MODRM, DA_Eb, 0
		instdesc	 setns, DA_NONE+DA_MODRM, DA_Eb, 0
		instdesc	 setp, DA_NONE+DA_MODRM, DA_Eb, 0
		instdesc	 setnp, DA_NONE+DA_MODRM, DA_Eb, 0
		instdesc	 setl, DA_NONE+DA_MODRM, DA_Eb, 0
		instdesc	 setnl, DA_NONE+DA_MODRM, DA_Eb, 0
		instdesc	 setle, DA_NONE+DA_MODRM, DA_Eb, 0
		instdesc	 setnle, DA_NONE+DA_MODRM, DA_Eb, 0

.inst0fa:	instdesc	 push, DA_QUAD, DA_Si, 0
		instdesc	 pop, DA_QUAD, DA_Si, 0
		instdesc	 cpuid, DA_NONE, 0, 0
		instdesc	 bt, DA_LONG+DA_MODRM, DA2_R_E, 0
		instdesc	 shld, DA_LONG+DA_MODRM, DA3_Ib_R_E, 0
		instdesc	 shld, DA_LONG+DA_MODRM, DA3_CL_R_E, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE+DA_MODRM, 0, .grpB

		instdesc	 push, DA_QUAD, DA_Si, 0
		instdesc	 pop, DA_QUAD, DA_Si, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 bts, DA_LONG+DA_MODRM, DA2_R_E, 0
		instdesc	 shrd, DA_LONG+DA_MODRM, DA3_Ib_R_E, 0
		instdesc	 shrd, DA_LONG+DA_MODRM, DA3_CL_R_E, 0
		instdesc	 0, DA_NONE+DA_MODRM, DA_E, .grp9
		instdesc	 imul, DA_LONG+DA_MODRM, DA2_E_R, 0

.inst0fb:	instdesc	 cmpxchg, DA_BYTE+DA_MODRM, DA2_R_E, 0
		instdesc	 cmpxchg, DA_LONG+DA_MODRM, DA2_R_E, 0
		instdesc	 lss, DA_LONG+DA_MODRM, DA2_E_R, 0
		instdesc	 btr, DA_LONG+DA_MODRM, DA2_R_E, 0
		instdesc	 lfs, DA_LONG+DA_MODRM, DA2_E_R, 0
		instdesc	 lgs, DA_LONG+DA_MODRM, DA2_E_R, 0
		instdesc	 movzb, DA_LONG+DA_MODRM, DA2_Eb_R, 0
		instdesc	 movzw, DA_LONG+DA_MODRM, DA2_Ew_R, 0

		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_LONG+DA_MODRM, DA2_Ib_E, .grp8
		instdesc	 btc, DA_LONG+DA_MODRM, DA2_R_E, 0
		instdesc	 bsf, DA_LONG+DA_MODRM, DA2_E_R, 0
		instdesc	 bsr, DA_LONG+DA_MODRM, DA2_E_R, 0
		instdesc	 movsb, DA_LONG+DA_MODRM, DA2_Eb_R, 0
		instdesc	 movsw, DA_LONG+DA_MODRM, DA2_Ew_R, 0

.inst0fc:	instdesc	 xadd, DA_BYTE+DA_MODRM, DA2_R_E, 0
		instdesc	 xadd, DA_LONG+DA_MODRM, DA2_R_E, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE+DA_MODRM, DA_E, .grpA

		instdesc	 bswap, DA_LONG, DA_Ril, 0
		instdesc	 bswap, DA_LONG, DA_Ril, 0
		instdesc	 bswap, DA_LONG, DA_Ril, 0
		instdesc	 bswap, DA_LONG, DA_Ril, 0
		instdesc	 bswap, DA_LONG, DA_Ril, 0
		instdesc	 bswap, DA_LONG, DA_Ril, 0
		instdesc	 bswap, DA_LONG, DA_Ril, 0
		instdesc	 bswap, DA_LONG, DA_Ril, 0

.esc92:		inststr		fnop
		inststr		0
		inststr		0
		inststr		0
		inststr		0
		inststr		0
		inststr		0
		inststr		0

.esc94:		inststr		fchs
		inststr		fabs
		inststr		0
		inststr		0
		inststr		ftst
		inststr		fxam
		inststr		0
		inststr		0

.esc95:		inststr		fld1
		inststr		fldl2t
		inststr		fldl2e
		inststr		fldpi
		inststr		fldlg2
		inststr		fldln2
		inststr		fldz
		inststr		0

.esc96:		inststr		f2xm1
		inststr		fyl2x
		inststr		fptan
		inststr		fpatan
		inststr		fxtract
		inststr		fprem1
		inststr		fdecstp
		inststr		fincstp

.esc97:		inststr		fprem
		inststr		fyl2xp1
		inststr		fsqrt
		inststr		fsincos
		inststr		frndint
		inststr		fscale
		inststr		fsin
		inststr		fcos

.esca5:		inststr		0
		inststr		fucompp
		inststr		0
		inststr		0
		inststr		0
		inststr		0
		inststr		0
		inststr		0

.escb4:		inststr		fneni
		inststr		fndisi
		inststr		fnclex
		inststr		fninit
		inststr		fsetpm
		inststr		0
		inststr		0
		inststr		0

.esce3:		inststr		0
		inststr		fcompp
		inststr		0
		inststr		0
		inststr		0
		inststr		0
		inststr		0
		inststr		0

.escf4:		inststr		fnstsw
		inststr		0
		inststr		0
		inststr		0
		inststr		0
		inststr		0
		inststr		0
		inststr		0

.esc8:		instdesc	fadd, DA_SNGL, DA2_STI_ST, 0
		instdesc	fmul, DA_SNGL, DA2_STI_ST, 0
		instdesc	fcom, DA_SNGL, DA2_STI_ST, 0
		instdesc	fcomp, DA_SNGL, DA2_STI_ST, 0
		instdesc	fsub, DA_SNGL, DA2_STI_ST, 0
		instdesc	fsubr, DA_SNGL, DA2_STI_ST, 0
		instdesc	fdiv, DA_SNGL, DA2_STI_ST, 0
		instdesc	fdivr, DA_SNGL, DA2_STI_ST, 0

.esc9:		instdesc	fld, DA_SNGL, DA_STI, 0
		instdesc	0, DA_NONE, DA_STI,fxch
		instdesc	fst, DA_SNGL, DA_X, .esc92
		instdesc	fstp, DA_SNGL, DA_X, 0
		instdesc	fldenv, DA_NONE, DA_X, .esc94
		instdesc	fldcw, DA_NONE, DA_X, .esc95
		instdesc	fnstenv, DA_NONE, DA_X, .esc96
		instdesc	fnstcw, DA_NONE, DA_X, .esc97

.esca:		instdesc	fiadd, DA_LONG, 0, 0
		instdesc	fimul, DA_LONG, 0, 0
		instdesc	ficom, DA_LONG, 0, 0
		instdesc	ficomp, DA_LONG, 0, 0
		instdesc	fisub, DA_LONG, DA_X, 0
		instdesc	fisubr, DA_LONG, 0, 0
		instdesc	fidiv, DA_LONG, 0, 0
		instdesc	fidivr, DA_LONG, 0, 0

.escb:		instdesc	fild, DA_LONG, 0, 0
		instdesc	0, DA_NONE, 0, 0
		instdesc	fist, DA_LONG, 0, 0
		instdesc	fistp, DA_LONG, 0, 0
		instdesc	0, DA_WORD, DA_X, .escb4
		instdesc	fld, DA_EXTR, 0, 0
		instdesc	0, DA_NONE, 0, 0
		instdesc	fstp, DA_EXTR, 0, 0

.escc:		instdesc	fadd, DA_DBLR, DA2_STI_ST, 0
		instdesc	fmul, DA_DBLR, DA2_STI_ST, 0
		instdesc	fcom, DA_DBLR, DA2_STI_ST, 0
		instdesc	fcomp, DA_DBLR, DA2_STI_ST, 0
		instdesc	fsub, DA_DBLR, DA2_STI_ST, 0
		instdesc	fsubr, DA_DBLR, DA2_STI_ST, 0
		instdesc	fdiv, DA_DBLR, DA2_STI_ST, 0
		instdesc	fdivr, DA_DBLR, DA2_STI_ST, 0

.escd:		instdesc	fld, DA_DBLR, DA_STI,ffree
		instdesc	0, DA_NONE, 0, 0
		instdesc	fst, DA_DBLR, DA_STI, 0
		instdesc	fstp, DA_DBLR, DA_STI, 0
		instdesc	frstor, DA_NONE, DA_STI,fucom
		instdesc	0, DA_NONE, DA_STI,fucomp
		instdesc	fnsave, DA_NONE, 0, 0
		instdesc	fnstsw, DA_NONE, 0, 0

.esce:		instdesc	fiadd, DA_WORD, DA2_ST_STI,faddp
		instdesc	fimul, DA_WORD, DA2_ST_STI,fmulp
		instdesc	ficom, DA_WORD, 0, 0
		instdesc	ficomp, DA_WORD, DA_X, .esce3
		instdesc	fisub, DA_WORD, DA2_ST_STI,fsubrp
		instdesc	fisubr, DA_WORD, DA2_ST_STI,fsubp
		instdesc	fidiv, DA_WORD, DA2_ST_STI,fdivrp
		instdesc	fidivr, DA_WORD, DA2_ST_STI,fdivp

.escf:		instdesc	fild, DA_WORD, 0, 0
		instdesc	0, DA_NONE, 0, 0
		instdesc	fist, DA_WORD, 0, 0
		instdesc	fistp, DA_WORD, 0, 0
		instdesc	fbld, DA_NONE, DA_X, .escf4
		instdesc	fild, DA_QUAD, 0, 0
		instdesc	fbstp, DA_NONE, 0, 0
		instdesc	fistp, DA_QUAD, 0, 0

.inst_tbl:	instdesc	 add, DA_BYTE+DA_MODRM, DA2_R_E, 0		;00
		instdesc	 add, DA_LONG+DA_MODRM, DA2_R_E, 0
		instdesc	 add, DA_BYTE+DA_MODRM, DA2_E_R, 0
		instdesc	 add, DA_LONG+DA_MODRM, DA2_E_R, 0
		instdesc	 add, DA_BYTE, DA2_Ib_A, 0
		instdesc	 add, DA_LONG, DA2_I_A, 0
		instdesc	 0, DA_NONE, DA_Si, 0
		instdesc	 0, DA_NONE, DA_Si, 0

		instdesc	 or, DA_BYTE+DA_MODRM, DA2_R_E, 0		;08
		instdesc	 or, DA_LONG+DA_MODRM, DA2_R_E, 0
		instdesc	 or, DA_BYTE+DA_MODRM, DA2_E_R, 0
		instdesc	 or, DA_LONG+DA_MODRM, DA2_E_R, 0
		instdesc	 or, DA_BYTE, DA2_Ib_A, 0
		instdesc	 or, DA_LONG, DA2_I_A, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0

		instdesc	 adc, DA_BYTE+DA_MODRM, DA2_R_E, 0		;10
		instdesc	 adc, DA_LONG+DA_MODRM, DA2_R_E, 0
		instdesc	 adc, DA_BYTE+DA_MODRM, DA2_E_R, 0
		instdesc	 adc, DA_LONG+DA_MODRM, DA2_E_R, 0
		instdesc	 adc, DA_BYTE, DA2_Ib_A, 0
		instdesc	 adc, DA_LONG, DA2_I_A, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0

		instdesc	 sbb, DA_BYTE+DA_MODRM, DA2_R_E, 0		;18
		instdesc	 sbb, DA_LONG+DA_MODRM, DA2_R_E, 0
		instdesc	 sbb, DA_BYTE+DA_MODRM, DA2_E_R, 0
		instdesc	 sbb, DA_LONG+DA_MODRM, DA2_E_R, 0
		instdesc	 sbb, DA_BYTE, DA2_Ib_A, 0
		instdesc	 sbb, DA_LONG, DA2_I_A, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0

		instdesc	 and, DA_BYTE+DA_MODRM, DA2_R_E, 0		;20
		instdesc	 and, DA_LONG+DA_MODRM, DA2_R_E, 0
		instdesc	 and, DA_BYTE+DA_MODRM, DA2_E_R, 0
		instdesc	 and, DA_LONG+DA_MODRM, DA2_E_R, 0
		instdesc	 and, DA_BYTE, DA2_Ib_A, 0
		instdesc	 and, DA_LONG, DA2_I_A, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0

		instdesc	 sub, DA_BYTE+DA_MODRM, DA2_R_E, 0		;28
		instdesc	 sub, DA_LONG+DA_MODRM, DA2_R_E, 0
		instdesc	 sub, DA_BYTE+DA_MODRM, DA2_E_R, 0
		instdesc	 sub, DA_LONG+DA_MODRM, DA2_E_R, 0
		instdesc	 sub, DA_BYTE, DA2_Ib_A, 0
		instdesc	 sub, DA_LONG, DA2_I_A, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0

		instdesc	 xor, DA_BYTE+DA_MODRM, DA2_R_E, 0		;30
		instdesc	 xor, DA_LONG+DA_MODRM, DA2_R_E, 0
		instdesc	 xor, DA_BYTE+DA_MODRM, DA2_E_R, 0
		instdesc	 xor, DA_LONG+DA_MODRM, DA2_E_R, 0
		instdesc	 xor, DA_BYTE, DA2_Ib_A, 0
		instdesc	 xor, DA_LONG, DA2_I_A, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0

		instdesc	 cmp, DA_BYTE+DA_MODRM, DA2_R_E, 0		;38
		instdesc	 cmp, DA_BYTE+DA_MODRM, DA2_R_E, 0
		instdesc	 cmp, DA_BYTE+DA_MODRM, DA2_E_R, 0
		instdesc	 cmp, DA_LONG+DA_MODRM, DA2_E_R, 0
		instdesc	 cmp, DA_BYTE, DA2_Ib_A, 0
		instdesc	 cmp, DA_LONG, DA2_I_A, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0

		instdesc	 0, DA_LONG, DA_Ri, 0				;40
		instdesc	 0, DA_LONG, DA_Ri, 0
		instdesc	 0, DA_LONG, DA_Ri, 0
		instdesc	 0, DA_LONG, DA_Ri, 0
		instdesc	 0, DA_LONG, DA_Ri, 0
		instdesc	 0, DA_LONG, DA_Ri, 0
		instdesc	 0, DA_LONG, DA_Ri, 0
		instdesc	 0, DA_LONG, DA_Ri, 0

		instdesc	 0, DA_LONG, DA_Ri, 0				;48
		instdesc	 0, DA_LONG, DA_Ri, 0
		instdesc	 0, DA_LONG, DA_Ri, 0
		instdesc	 0, DA_LONG, DA_Ri, 0
		instdesc	 0, DA_LONG, DA_Ri, 0
		instdesc	 0, DA_LONG, DA_Ri, 0
		instdesc	 0, DA_LONG, DA_Ri, 0
		instdesc	 0, DA_LONG, DA_Ri, 0

		instdesc	 push, DA_QUAD, DA_Ri, 0			;50
		instdesc	 push, DA_QUAD, DA_Ri, 0
		instdesc	 push, DA_QUAD, DA_Ri, 0
		instdesc	 push, DA_QUAD, DA_Ri, 0
		instdesc	 push, DA_QUAD, DA_Ri, 0
		instdesc	 push, DA_QUAD, DA_Ri, 0
		instdesc	 push, DA_QUAD, DA_Ri, 0
		instdesc	 push, DA_QUAD, DA_Ri, 0

		instdesc	 pop, DA_QUAD, DA_Ri, 0				;58
		instdesc	 pop, DA_QUAD, DA_Ri, 0
		instdesc	 pop, DA_QUAD, DA_Ri, 0
		instdesc	 pop, DA_QUAD, DA_Ri, 0
		instdesc	 pop, DA_QUAD, DA_Ri, 0
		instdesc	 pop, DA_QUAD, DA_Ri, 0
		instdesc	 pop, DA_QUAD, DA_Ri, 0
		instdesc	 pop, DA_QUAD, DA_Ri, 0

		instdesc	 0, DA_LONG, 0, 0				;60
		instdesc	 0, DA_LONG, 0, 0
		instdesc	 0, DA_LONG+DA_MODRM, DA2_E_R, 0
		instdesc	 movsxd, DA_LONG+DA_MODRM, DA2_E_R, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0

		instdesc	 push, DA_LONG, DA_I, 0				;68
		instdesc	 imul, DA_LONG+DA_MODRM, DA3_I_E_R, 0
		instdesc	 push, DA_QUAD, DA_Iq, 0
		instdesc	 imul, DA_LONG+DA_MODRM, DA3_Ib_E_R, 0
		instdesc	 ins, DA_BYTE, DA2_DX_DI, 0
		instdesc	 ins, DA_LONG, DA2_DX_DI, 0
		instdesc	 outs, DA_BYTE, DA2_SI_DX, 0
		instdesc	 outs, DA_LONG, DA2_SI_DX, 0

		instdesc	 jo, DA_NONE, DA_Db, 0				;70
		instdesc	 jno, DA_NONE, DA_Db, 0
		instdesc	 jb, DA_NONE, DA_Db, 0
		instdesc	 jnb, DA_NONE, DA_Db, 0
		instdesc	 jz, DA_NONE, DA_Db, 0
		instdesc	 jnz, DA_NONE, DA_Db, 0
		instdesc	 jbe, DA_NONE, DA_Db, 0
		instdesc	 jnbe, DA_NONE, DA_Db, 0

		instdesc	 js, DA_NONE, DA_Db, 0				;78
		instdesc	 jns, DA_NONE, DA_Db, 0
		instdesc	 jp, DA_NONE, DA_Db, 0
		instdesc	 jnp, DA_NONE, DA_Db, 0
		instdesc	 jl, DA_NONE, DA_Db, 0
		instdesc	 jnl, DA_NONE, DA_Db, 0
		instdesc	 jle, DA_NONE, DA_Db, 0
		instdesc	 jnle, DA_NONE, DA_Db, 0

		instdesc	 0, DA_BYTE+DA_MODRM, DA2_I_E, .grp1		;80
		instdesc	 0, DA_LONG+DA_MODRM, DA2_I_E, .grp1
		instdesc	 0, DA_BYTE+DA_MODRM, DA2_Ib_E, .grp1
		instdesc	 add, DA_LONG+DA_MODRM, DA2_Ib_E, 0
		instdesc	 test, DA_BYTE+DA_MODRM, DA2_R_E, 0
		instdesc	 test, DA_LONG+DA_MODRM, DA2_R_E, 0
		instdesc	 xchg, DA_BYTE+DA_MODRM, DA2_R_E, 0
		instdesc	 xchg, DA_LONG+DA_MODRM, DA2_R_E, 0

		instdesc	 mov, DA_BYTE+DA_MODRM, DA2_R_E, 0		;88
		instdesc	 mov, DA_LONG+DA_MODRM, DA2_R_E, 0
		instdesc	 mov, DA_BYTE+DA_MODRM, DA2_E_R, 0
		instdesc	 mov, DA_LONG+DA_MODRM, DA2_E_R, 0
		instdesc	 mov, DA_NONE+DA_MODRM, DA2_S_Ew, 0
		instdesc	 lea, DA_LONG+DA_MODRM, DA2_E_R, 0
		instdesc	 mov, DA_NONE+DA_MODRM, DA2_Ew_S, 0
		instdesc	 pop, DA_QUAD+DA_MODRM, DA_E, 0

		instdesc	 nop, DA_NONE, 0, 0				;90
		instdesc	 xchg, DA_LONG, DA2_A_Ri, 0
		instdesc	 xchg, DA_LONG, DA2_A_Ri, 0
		instdesc	 xchg, DA_LONG, DA2_A_Ri, 0
		instdesc	 xchg, DA_LONG, DA2_A_Ri, 0
		instdesc	 xchg, DA_LONG, DA2_A_Ri, 0
		instdesc	 xchg, DA_LONG, DA2_A_Ri, 0
		instdesc	 xchg, DA_LONG, DA2_A_Ri, 0

		instdesc	 cbw, DA_SDEP, 0,cdqe				;9A
		instdesc	 cwd, DA_SDEP, 0,cqo
		instdesc	 0, DA_NONE, DA_OS, 0
		instdesc	 wait, DA_NONE, 0, 0
		instdesc	 pushf, DA_QUAD, 0, 0
		instdesc	 popf, DA_QUAD, 0, 0
		instdesc	 sahf, DA_NONE, 0, 0
		instdesc	 lahf, DA_NONE, 0, 0

		instdesc	 mov, DA_BYTE, DA2_O_A, 0			;A0
		instdesc	 mov, DA_LONG, DA2_O_A, 0
		instdesc	 mov, DA_BYTE, DA2_A_O, 0
		instdesc	 mov, DA_LONG, DA2_A_O, 0
		instdesc	 movsb, DA_BYTE, 0, 0
		instdesc	 movsd, DA_LONG, 0, 0
		instdesc	 cmpsb, DA_BYTE, 0, 0
		instdesc	 cmpsd, DA_LONG, 0, 0

		instdesc	 test, DA_BYTE, DA2_I_A, 0			;A8
		instdesc	 test, DA_LONG, DA2_I_A, 0
		instdesc	 stosb, DA_BYTE, 0, 0
		instdesc	 stosw, DA_WORD, 0, 0
		instdesc	 lodsb, DA_BYTE, 0, 0
		instdesc	 lodsw, DA_WORD, 0, 0
		instdesc	 scasb, DA_BYTE, 0, 0
		instdesc	 scasd, DA_LONG, 0, 0

		instdesc	 mov, DA_BYTE, DA2_Ib_Ri, 0			;B0
		instdesc	 mov, DA_BYTE, DA2_Ib_Ri, 0
		instdesc	 mov, DA_BYTE, DA2_Ib_Ri, 0
		instdesc	 mov, DA_BYTE, DA2_Ib_Ri, 0
		instdesc	 mov, DA_BYTE, DA2_Ib_Ri, 0
		instdesc	 mov, DA_BYTE, DA2_Ib_Ri, 0
		instdesc	 mov, DA_BYTE, DA2_Ib_Ri, 0
		instdesc	 mov, DA_BYTE, DA2_Ib_Ri, 0

		instdesc	 mov, DA_LONG, DA2_I_Ri, 0			;B8
		instdesc	 mov, DA_LONG, DA2_I_Ri, 0
		instdesc	 mov, DA_LONG, DA2_I_Ri, 0
		instdesc	 mov, DA_LONG, DA2_I_Ri, 0
		instdesc	 mov, DA_LONG, DA2_I_Ri, 0
		instdesc	 mov, DA_LONG, DA2_I_Ri, 0
		instdesc	 mov, DA_LONG, DA2_I_Ri, 0
		instdesc	 mov, DA_LONG, DA2_I_Ri, 0

		instdesc	 0, DA_BYTE+DA_MODRM, DA2_Ib_E, .grp2		;C0
		instdesc	 0, DA_LONG+DA_MODRM, DA2_Ib_E, .grp2
		instdesc	 ret, DA_NONE, DA_Iw, 0
		instdesc	 ret, DA_NONE, 0, 0
		instdesc	 0, DA_LONG+DA_MODRM, DA2_E_R, 0
		instdesc	 0, DA_LONG+DA_MODRM, DA2_E_R, 0
		instdesc	 mov, DA_BYTE+DA_MODRM, DA2_I_E, 0
		instdesc	 mov, DA_LONG+DA_MODRM, DA2_I_E, 0

		instdesc	 enter, DA_NONE, DA2_Iq_Ib, 0			;C8
		instdesc	 leave, DA_NONE, 0, 0
		instdesc	 lret, DA_NONE, DA_Iw, 0
		instdesc	 lret, DA_NONE, 0, 0
		instdesc	 int, DA_NONE, DA_o3, 0
		instdesc	 int, DA_NONE, DA_Ib, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 iret, DA_NONE, 0, 0

		instdesc	 0, DA_BYTE+DA_MODRM, DA2_o1_E, .grp2		;D0
		instdesc	 0, DA_LONG+DA_MODRM, DA2_o1_E, .grp2
		instdesc	 0, DA_BYTE+DA_MODRM, DA2_CL_E, .grp2
		instdesc	 0, DA_LONG+DA_MODRM, DA2_CL_E, .grp2
		instdesc	 0, DA_NONE+DA_MODRM, DA_Ib, 0
		instdesc	 0, DA_NONE+DA_MODRM, DA_Ib, 0
		instdesc	 db_0D6h, DA_NONE, 0, 0
		instdesc	 xlat, DA_BYTE, DA_BX, 0

		instdesc	 0, DA_NONE+DA_MODRM, 0, .esc8			;D8
		instdesc	 0, DA_NONE+DA_MODRM, 0, .esc9
		instdesc	 0, DA_NONE+DA_MODRM, 0, .esca
		instdesc	 0, DA_NONE+DA_MODRM, 0, .escb
		instdesc	 0, DA_NONE+DA_MODRM, 0, .escc
		instdesc	 0, DA_NONE+DA_MODRM, 0, .escd
		instdesc	 0, DA_NONE+DA_MODRM, 0, .esce
		instdesc	 0, DA_NONE+DA_MODRM, 0, .escf

		instdesc	 loopne, DA_NONE, DA_Db, 0			;E0
		instdesc	 loope, DA_NONE, DA_Db, 0
		instdesc	 loop, DA_NONE, DA_Db, 0
		instdesc	 jcxz, DA_SDEP, DA_Db,jrcxz
		instdesc	 in, DA_BYTE, DA2_Ib_A, 0
		instdesc	 in, DA_LONG, DA2_Ib_A, 0
		instdesc	 out, DA_BYTE, DA2_A_Ib, 0
		instdesc	 out, DA_LONG, DA2_A_Ib, 0

		instdesc	 call, DA_LONG, DA_Dl, 0			;E8
		instdesc	 jmp, DA_NONE, DA_Dl, 0
		instdesc	 0, DA_NONE, DA_OS, 0
		instdesc	 jmp, DA_NONE, DA_Db, 0
		instdesc	 in, DA_BYTE, DA2_DX_A, 0
		instdesc	 in, DA_LONG, DA2_DX_A, 0
		instdesc	 out, DA_BYTE, DA2_A_DX, 0
		instdesc	 out, DA_LONG, DA2_A_DX, 0

		instdesc	 0, DA_NONE, 0, 0				;F0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 0, DA_NONE, 0, 0
		instdesc	 hlt, DA_NONE, 0, 0
		instdesc	 cmc, DA_NONE, 0, 0
		instdesc	 0, DA_BYTE+DA_MODRM, 0, .grp3
		instdesc	 0, DA_LONG+DA_MODRM, 0, .grp3

		instdesc	 clc, DA_NONE, 0, 0				;F8
		instdesc	 stc, DA_NONE, 0, 0
		instdesc	 cli, DA_NONE, 0, 0
		instdesc	 sti, DA_NONE, 0, 0
		instdesc	 cld, DA_NONE, 0, 0
		instdesc	 std, DA_NONE, 0, 0
		instdesc	 0, DA_NONE+DA_MODRM, 0, .grp4
		instdesc	 0, DA_NONE+DA_MODRM, 0, .grp5
.inst_tbl_end:

.inst0f:        dw                      .inst0f0-.disasm_tbl
                dw                      0;1
                dw                      .inst0f2-.disasm_tbl
                dw                      .inst0f3-.disasm_tbl
                dw                      0;4
                dw                      0;5
                dw                      0;6
                dw                      0;7
                dw                      .inst0f8-.disasm_tbl
                dw                      .inst0f9-.disasm_tbl
                dw                      .inst0fa-.disasm_tbl
                dw                      .inst0fb-.disasm_tbl
                dw                      .inst0fc-.disasm_tbl
                dw                      0;d
                dw                      0;e
                dw                      0;f

.instesc:       dw                      .esc8-.disasm_tbl
                dw                      .esc9-.disasm_tbl
                dw                      .esca-.disasm_tbl
                dw                      .escb-.disasm_tbl
                dw                      .escc-.disasm_tbl
                dw                      .escd-.disasm_tbl
                dw                      .esce-.disasm_tbl
                dw                      .escf-.disasm_tbl

.sizestr:       dq                      "byte"
                dq                      "word"
                dq                      "dword"
                dq                      "qword"
                dq                      "single"
                dq                      "double"
                dq                      "extend"

.reg0:          dq                      "al", "cl", "dl", "bl", "ah", "ch", "dh", "bh", "r8b", "r9b", "r10b", "r11b", "r12b", "r13b", "r14b", "r15b"
.reg1:          dq                      "ax", "cx", "dx", "bx", "sp", "bp", "si", "di", "r8w", "r9w", "r10w", "r11w", "r12w", "r13w", "r14w", "r15w"
.reg2:          dq                      "eax", "ecx", "edx", "ebx", "esp", "ebp", "esi", "edi", "r8d", "r9d", "r10d", "r11d", "r12d", "r13d", "r14d", "r15d"
.reg3:          dq                      "rax", "rcx", "rdx", "rbx", "rsp", "rbp", "rsi", "rdi", "r8", "r9", "r10", "r11", "r12", "r13", "r14", "r15"
.reg:           dq                      .reg0, .reg1, .reg2, .reg3

.segreg:        dd                      "es", "cs", "ss", "ds", "fs", "gs", "", ""

.ripreg:        db                      "rip",0
.lockstr:       db                      "lock ",0
.repnzstr:      db                      "repnz ",0
.repestr:       db                      "repe ",0
.str3dnow:      db                      "(3Dnow!)",0
.syscallstr:	db			"syscall XXXX",0
.unkmnemonic:   db                      "???",0

